Copyright: Kickstart for Paradox Copyright® 1994 Datacraft


CONTENTS
Contents (Working Demo Version)

 Introduction - Welcome to Kickstart

 Features - What Kickstart will do for you

 Instructions - How to make Kickstart work for you

 The Paradox Kickstart Expert

 Ordering Information

 Technical Support

 About Datacraft, Inc.

Credits


Introduction
Kickstart Introduction

Kickstart for Paradox is a utility that allows the Paradox for Windows developer to start applications from a single executable (.EXE file) which greatly simplifies the distribution and command line configuration of your applications.

Because of the  myriad of command line options, not only is it  a tedious matter to install Paradox applications as an icon in the Microsoft Windows Program Manager (tm),  but there is no way to prevent adventurous users from modifying it. Furthermore, the DOS/Windows limit of 128 characters on the command line will prevent the installation of applications in nested directories or directories with long names.

Kickstart elegantly solves these problems by reading startup command line options from a custom initialization (.INI)  file in the application's directory.  This technique will reduce  the command line in the Program Manager to a simple call to an executable (.EXE) file much like any other Windows application.

Contents

Instructions


Kickstart Instructions

Getting Started

Creating a Custom Kickstart File for your Application

Example of a  KIKSTART.INI file

Exceeding the Windows/DOS 128 Character Command Line Limit

IMPORTANT! -  KIKSTART.INI Configuration Parameters

KIKSTART.EXE Command Line Options

Advanced Options

Installing KIKSTART.EXE in the MS Windows Program Manager

The Paradox Kickstart Expert

Peer to Peer Network Configuration

Back To: Contents


Creating a Custom Kickstart File

Creating a custom Kickstart file is a simple matter. Copy the files KIKSTART.EXE and KIKSTART.INI to the desired directory.  The KIKSTART.EXE/.INI  files can be renamed to any legal DOS file name.

The accompanying (.INI) file MUST have the same name and reside in the same directory.

Example:

C:\>COPY C:\KIKSTART\KIKSTART.EXE D:\APP\MYAPP.EXE

C:\>COPY C:\KIKSTART\KIKSTART.INI D:\APP\MYAPP.INI

See Also:

Back To:  Instructions

Using the Paradox Kickstart Expert


Kickstart Expert
The Paradox Kickstart Expert

Welcome to the Kickstart Command Line Configuration Expert

The Kickstart Command Line Configuration Expert is a Paradox 5.0 compatible Expert that easily walks you through the Kickstart configuration process.

The Kickstart Expert performs the following functions:

1 	Allows you to specify all Paradox command line parameters in easy-to-fill-in fields. Context sensitive help is available at any time by pressing Alt+P or clicking on the Help button.

You may load default values from the KIKSTART.INI file by clicking on the Load Defaults button.

2 	Validates data entry fields. If specified directories are not found, the Kickstart Expert will confirm and create them for you.

3 	Creates a new instance of Kickstart by copying KIKSTART.EXE and KIKSTART.INI to the file names and directory of your choosing.

4 	Creates a program group of your choosing in the MS Windows Program Manager and installs your new application executable in it.

See Also:

Expert Help Contents

Kickstart Contents

Kickstart Instructions


Expert Help Contents
Kickstart Expert  Help Contents

Overview

See: Kickstart Expert Overview

Kickstart Expert Buttons

 See: Kickstart Expert Buttons

Kickstart Expert Fields

ExeFileName

Paradox Version

Working Dir

Private Dir

Installation Type

IDAPI File

PDOXWIN.INI File

Startup Flags

Minimum Free Disk Space

Startup Form or Script

Program Group Options

Application Path

Application Name

Loading Message


Expert Buttons
Expert:  Buttons

The following buttons are available in the Kickstart Expert.

Cancels and closes the Kickstart Expert

Open an existing INI file and edit the contents.

Calls context sensitive file and directory browser. You must be on file name or directory field for this button to be active.

Calls context sensitive help system.

Goes to the previous or next page. If the current page's data is invalid, you will not be allowed to advance.

Loads default flags into the Startup Flags field.

Loads the Expert with default values from the DEFAULT.INI file found in Kickstart's home directory.

Saves the current expert settings to the DEFAULT.INI file in Kickstart's home directory.

Performs final validation and runs Expert.


ExeFileName
Expert: ExeFileName

Required Field

The ExeFileName field refers to the full path and file name of Paradox or Paradox Runtime.

Example:

C:\PDOXWIN\PDOXWIN.EXE
 or....

C:\PDOXRUN\PFWRUN.EXE

Expert Help Contents


Paradox Version
Expert:  Paradox Version

Required Field

This setting tells Paradox to either use the IDAPI or ODAPI configurations.

See Also:

Expert Help Contents


Working Dir
Expert: Working Dir

Required Field

This field refers to the Paradox working directory, not the Windows working directory. In most cases, this should be the home directory for your application.

If the directory you entered does not exist, Kickstart will prompt you to create it.

Example:

R:\APPS\MYAPP

Expert Help Contents


Private Dir
Expert: Private Dir

Required Field

The full drive and path to the Paradox private directory for a given workstation.

If the directory you entered does not exist, Kickstart will prompt you to create it.

Example:

C:\APPS\PRIVATE

Many network operating systems give you the option of logically mapping all private user directories to a single drive letter, yet all directories would be in a different physical location on the drive. If this is your case,  then select Kickstart's Server Installation Type option. Otherwise select the Local option.

Installation Type Option

Expert Help Contents


Installation Type
Expert: Installation Type

Required

Local Setting:

A local setting passes the ExeFileName and the Private directory to launching utility as command line parameters which override those parameters in the KIKSTART.INI file. You would want to use this option for two reasons.

1 	You want a particular workstation to call Paradox from the local hard drive for performance purposes.

2 	The private directories on your network are not mapped to a single drive letter. Therefore, each workstation must specify a unique private directory.

Example:

;This is what would appear in your Windows Program ;Item Properties dialog box in the Program Manager
;

MYAPP.EXE -lC:\PDOXWIN\PDOXWIN.EXE -pC:\PRIVATE

An alternative would be to install the Kickstart files in the workstation's private directory, and simply point to your application start up file on a shared directory.

Server Setting:

Many network operating systems give you the option of logically mapping all private user directories to a single drive letter, yet all directories would be in a different physical location on the drive. If this is your case,  then select Kickstart's Server Installation Type option.

Expert Help Contents


Idapi File
Expert: IDAPI File

Optional Field

This specifies the IDAPI (version 5.0) or ODAPI (version < 5) file you wish to use with your application. If this field is left blank, the Paradox will use the default IDAPI file specified in the WIN.INI file.

We strongly recommend you specify an application specific IDAPI file if for no other reason but to make sure that all users are pointing to the same network control file.

Expert Help Contents


PDOXWIN.INI File
Expert: PDOXWIN.INI File

Optional Field

Allows you to specify an alternate PDOXWIN.INI for your application. We strongly recommend you do this as the PDOXWIN.INI file contains several application specific settings. See your Paradox documentation for additional information.

See Also:

Expert Help Contents


Startup Flags
Expert: Startup Flags

Paradox has numerous command line flags which allow you to pass in  startup instructions.

We recommend the following flags: -m -q -c -e -n

-q Quiet Mode

Do not display the Paradox splash screen at startup.

-m Start Minimized

Creates a smoother startup by allowing you set up the desktop before revealing it to the user.

-c Start Paradox with a Clear Desktop

This makes certain Paradox does not automatically load any objects at startup.

-e  Do Not Write Changes to the PDOXWIN.INI File

Paradox saves the state of the desktop to the PDOXWIN.INI file upon exit.  If you are using an alternate PDOXWIN.INI file, you probably do not want it changed in any way.

-n  Do Not Write Changes to the WIN.INI File

You probably do not want your custom application to alter the Paradox's default settings in the WIN.INI file. Its part of being a good Windows citizen.

See Also:

Indepth Command Line Information

Expert Help Contents


Tag Flags
Tag: Flags=

Optional (recommended)

Recommended Flags

-q     Quiet Mode

-m    Minimize Paradox on start up

-c     Starts Paradox with a clear desktop

-e     Do NOT write changes to PDOXWIN.INI

-n     Do NOT write changes to WIN.INI

Example:

Flags=-q -m -c -e -n

Flags NOT Recommended

-f      Do write changes to PDOXWIN.INI

-y     Do write changes to WIN.INI

-i      Specifies alternate PDOXWIN.INI

-d     Specifies alternate PDOXWORK.INI

-s     Prevents users from resizing desktop

-o     Specifies alternate ODAPI.CFG

-t      Lets  users resize the desktop

-p     Specifies an alternate private directory

-w    Specifies an alternate working directory

Back To: KICKSTART.INI Tags


Quiet Mode
The -q flag starts Paradox without the Paradox splash screen and thermometer.


Minimize
Notes on Minimized Start-up:

A smooth startup can be achieved by starting Paradox in a minimized state. After setting the application title and menus, by declaring an application variable and using the maximize() method it (the application) pops open without flashing the Paradox menu or unwanted title.

Example:

;in your startup form's open method

var
  app   application
endvar

  app.setTitle("My App Title")
  DisplayMyAppMenu()  ;custom menu method
  app.maximize()


Clear DeskTop
Notes on Starting with Clear Desktop:

Use the -c flag to insure that Paradox start with a clear desktop.  It is a good idea to have a custom PDOXWIN.INI file for your application that among other things, lists windows displayed in a previous session. Paradox will try to open any of these windows the next time it starts if the -c flag is not used.  If the recommended -e flag is also used, the PDOXWIN.INI file will not be updated with the desktop contents from the current session, negating the need for the -c flag. Both flags should be used.

See:  HELP on the -e flag and the PdoxWinINI= and PdoxWorkINI= tags

-e Flag

PDOXWIN.INI

PDOXWORK.INI


Tag PdoxWinINI
Tag: PdoxWinINI=

Optional (strongly recommended)

The PdoxWinINI Tag refers to an alternate PDOXWIN.INI file to use. Paradox reads this file to get startup information for the appearance and property settings of the desktop,  a list of opened windows,  and settings for the designer.

Most importantly PDOXWIN.INI will contain settings that your application may depend on such as custom formats and BlanksIsZero .  See your Paradox manual for further information.

Note:  Paradox saves this file in your Windows directory but your alternate may be located in any directory.

Example:

PdoxWinINI=R:\APPS\GROUP\PWIN.INI

Back To: KICKSTART.INI Tags


Configuration Parameters
KIKSTART.INI Configuration Parameters

Sample KIKSTART.INI File

[KICKSTART]

ExeFileName=<Path and full name of Paradox Executable File>

Version=<Paradox version number (4.5 or 5.0) >

StartUpFile=<Path and full name application startup script or form>

PrivDir=<Paradox private directory>

WorkingDir=<Application working directory>

Flags=<Paradox command line flags>

IDAPIFile=<alternate IDAPI.CFG file name>

PdoxWinINI=<Alternate PDOXWIN.INI file name>

PdoxWorkINI=<Alternate PDOXWORK.INI file name>

AppSpace=<Minimum space on working directory drive>

PrivSpace=<Minimum space on private directory drive>

LoadingMsg=<Message to display while Paradox is loading>

Back To:  Instructions


Tag  ExeFileName
Tag:  ExeFileName=

Required

The Runtime tag refers to full path and name Paradox's executable file name.  This can be PDOXWIN.EXE or PFWRUN.EXE for either the interactive or the runtime versions respectively.

Example:

ExeFileName=R:\APPS\PW45\PDOXWIN.EXE

Local Paradox Installation Note:

For local installations of Paradox, (which means the data resides on the on the server but Paradox is installed on the local workstation),  the -L command line parameter can be added to Kickstart in the Program Manager to specify the full path and name of the locally installed files. The -L command line parameter over-rides the runtime tag in the custom INI file.

-L Parameter Example:

From the Program Manager:

R:\APPS\MYAPP\MYAPP.EXE -LC:\PW45\PDOXWIN.EXE

Back To: KICKSTART.INI Tags


Tag Version
Tag: Version=

Required

The version number refers to the Paradox version number, either 4.5 or 5.0. This is very important as it tells KIKSTART.EXE to look either for IDAPI or ODAPI references.

Example:

Version=5.0

Back To: KICKSTART.INI Tags


Tag StartUpFile
Tag: StartUpFile=

Optional

The StartUpFile tag refers to the full name and path of the Paradox script or form that starts your application. Be certain to include the complete file extension as shown in the example.

If you leave this tag blank, you will open Paradox up to an interactive session with the parameters specified in the INI file.

This is a good way to create different interactive sessions configured differently for different projects.

Example:

startUpfile=R:\APPS\GROUP\MYAPP.SDL

Back To: KICKSTART.INI Tags


Tag PrivDir
Tag: PrivDir=

Required

The PrivDir tag refers to the user's private directory. Each user MUST have a unique private directory.

On Novell networks,  a mapping feature allows the network administrator to map unique user directories to the root of a single drive letter.  With this configuration,  we can specify that drive letter as the private directory for Paradox, yet for each user the network maps to a unique physical location on the drive. While this configuration requires a little more work to setup initially,  maintenance and setup time is reduced for each individual workstation.

If this type of configuration is not available on your network, the -P command line parameter for KIKSTART.EXE can be used to insure unique private directories for each user.

 A trailing back slash is optional.

KIKSTART.INI Example:

PrivDir=H:\

KIKSTART.EXE Command Line Over-Ride Example:

From the Program Manager:

R:\APPS\GROUP\MYAPP.EXE -PE:\MYPRIV

Back To: KICKSTART.INI Tags


Tag WorkingDir
Tag: WorkingDir=

Required

The WorkingDir tag refers to the working directory of your application. KIKSTART.EXE does not have to be located in the application working directory.

A trailing backslash is optional.

Example:

WorkingDir=R:\APPS\GROUP

Back To: KICKSTART.INI Tags


Tag IdapiFile
Tag: IdapiFile=

Optional (strongly recommended)

The IdapiFile Tag refers to an alternate IDAPI.CFG file to use. This is important to insure that all users point to the same NET File, have the appropriate aliases and other configuration settings.

Example:

IdapiFile=R:\APPS\GROUP\IDAPI.CFG

Back To: KICKSTART.INI Tags


Tag PdoxWorkINI
Tag: PdoxWorkINI=

Optional

The PdoxWorkINI Tag refers to an alternate PDOXWORK.INI file to use.  Paradox uses this file to maintain the contents of the Folder and the position of the icons.  Specifying an alternative PDOXWORK.INI file is not necessary for most applications.

Example:

PdoxWorkINI=R:\APPS\GROUP\PWORK.INI

Back To: KICKSTART.INI Tags


CheckSpace
Tags: AppSpace=  and PrivSpace=

Optional (recommended)

The AppSpace and PrivSpace Tags refers to the minimum allowable disk space in bytes required to run your application.

AppSpace refers to the working directory drive
PrivSpace refers to the private directory drive

The rule of thumb is to have at least three times the size of your largest table in free disk space.

The benefit of checking drive space with Kickstart  instead of objectPAL code is that the end user will be notified of a discrepancy immediately instead of waiting for Paradox's load time.

Example:

;Express the minimum disk space in bytes using no
;commas or decimals.

;10 megabytes on the working directory drive
AppSpace=10000000

;8 megabytes on the private directory drive
PrivSpace=8000000

Back To: KICKSTART.INI Tags


Tag LoadingMsg
Tag: LoadingMsg=

Optional

KIKSTART.EXE will display a custom message while you application is loading.

Example

LoadingMsg=Please Wait While the Connections Application is Loading

The following dialog box will appear to the user as the application loads. A message greater than 75 characters will be truncated.  Word wrap and centering is automatic.

If LoadingMsg= is left blank, no message will appear at all.

Back To: KICKSTART.INI Tags


No PDOXWIN.INI and PDOXWORK.INI Changes
Notes on the -e Flag:

The -e flag prevents Paradox from writing changes to the PDOXWORK.INI and the PDOXWIN.INI files when it exits.

It is a good strategy to include an alternate PDOXWIN.INI file with your application because it holds settings for custom formats and other configuration items such as BlanksEqualZero.  The alternate PDOXWIN.INI can be renamed and used by your application via the PdoxWinINI=<tag> in the KIKSTART.INI file.


No Changes to WIN.INI
Notes for -n Flag:

Your application will typically use a number of custom settings that will not be appropriate for interactive use. Using the -n flag will keep any custom settings from being written to your WIN.INI file.


flag_fy
-f, -y Flags:

Changes should NOT be written to the PDOXWIN.INI, PDOXWORK.INI or the WIN.INI files or specified alternatives following the execution of your application.  Most applications will use specified alternatives to these files that once created, should not be changed.


Flag_i
-i Flag:

This flag is handled using the PdoxWinINI= tag in the KIKSTART.INI file and should not be used here.


Flag_d
-d Flag:

This flag is handled using the PdoxWorkINI= tag in the KIKSTART.INI file and should not be used here.


Flag_s
-s Flag:

For most applications the end users will want the ability to modify the size of the desktop like their other Windows applications.


Flag_o
-o Flag:

This flag is handled using the IdapiFile= tag in the KIKSTART.INI file and should not be used here.


Flag_t
-t  Flag:

The -t flag over-rides the -s flag and not necessary for most applications.


Flag_p
-p Flag:

This flag is handled using the PrivDir= tag in the KIKSTART.INI file and should not be used here.


Flag_w
-w Flag:

This flag is handled using the WorkingDir= tag in the KIKSTART.INI file and should not be used here.


Free Disk Space
Expert:  Free Disk Space

Optional Fields

Kickstart will check the free drive space on which the Private and Working directories are located and not allow the application to start unless the minimum space is available.

Specify the minimum space in bytes.

See Also:

Expert Help Contents


Startup File
Expert:  Startup Form or Script

Optional Field

Specify your application startup form or script. If left blank, Paradox will load to an interactive session without starting a form or script

See Also:

Expert Help Contents


Program Group Options
Expert:  Program Group Options

Required Fields if Create Group=Yes

Kickstart will automatically install your fully configured  application in the MS Windows Program Manager if the Create Group option is selected.  If you want Kickstart to do this, the following fields must be completed:

Application Desc:

The description of your application as it will appear in the MS Windows Program Group window

Group Name:

The Group name of your application as it will appear in the MS Windows Program Manager. If a program group already exists with the name you specified,  Kickstart will create a new group with the same name.

See Also:

Expert Help Contents


Application Path
Expert:  Application Path

Required Field

This is the full drive and path in which you want the Kickstart files (the renamed KIKSTART.EXE and KIKSTART.INI) installed. This may be different than your Working Directory.

If the directory you entered does not exist, Kickstart will prompt you to create it.

Example:

R:\APPS\MYAPP

See Also:

Expert Help Contents


Application Name
Expert:  Application Name

Required Field

This is the file name for your application's executable file name. KIKSTART.EXE and KIKSTART.INI are copied to your application path using the name specified in this field. You may use any legal DOS file name.

See Also:

Expert Help Contents


Loading Message
Expert: Loading Message

Required Field

KIKSTART.EXE will display a custom message while you application is loading.

The following dialog box will appear to the user as the application loads. A message greater than 75 characters will be truncated.  Word wrap and centering is automatic.

Back To: Expert Contents


Sample KIKSTART.INI File

[KICKSTART]

ExeFileName=R:\apps\pw5\pdoxwin.exe
Version=5.0
flags= -m -q -c -e -n
workingDir=d:\apps\group\
privDir=H:\
startUpfile=d:\apps\group\myapp.sdl
IdapiFile=d:\apps\group\myodapi.cfg
pdoxWorkINI=d:\apps\group\pwork.ini
pdoxWinINI= d:\apps\group\pwin.ini
appspace=1000000
privspace=20000000

This initialization file is paramount to the Kickstart system. Mixed case is used in the example for readability but as with all INI files, case is ignored.

The application tag [KICKSTART] surrounded by square brackets is required.

See Also:

Back To: Instructions


Exceeding Command Line Limits

By utilizing Paradox's startup cycle and strategically placing command line options in the appropriate sections of the WIN.INI file we can achieve the effect of exceeding the 128 character command line limit imposed by DOS and Windows.

The problem can still occur if a combination of the Flags, StartUpFile, PdoxWinINI, and PdoxWorkINI tags in the KIKSTART.INI file exceed 128 characters.  Since the PdoxWorkINI tag is rarely used, exceeding the limit is highly unlikely.

The original contents of the modified sections WIN.INI are saved and restored immediately following the call to the assigned ExeFileName file.

Back To:  Instructions


KIKSTART.EXE Command Line Options
KIKSTART.EXE Command Line Overrides

The following command line overrides are available when executing KIKSTART.EXE.

The command line option must NOT have a space between it and the switch.

-L[Local Installation of Paradox Over-Ride]

R:\APPS\GROUP\MYAPP.EXE -LC:\PDOXWIN\PDOXWIN.EXE

-P[Private Directory Over-Ride]

R:\APPS\GROUP\MYAPP.EXE -PE:\MYPRIV\

-I[Path and Name of Alternate KIKSTART.INI File]

This makes KIKSTART.EXE use a different INI file.

R:\APPS\GROUP\MYAPP.EXE -IC:\PRIV\MYAPP.INI

See Also:

ExeFileName= Options

PrivDir= Options

BACK TO: Instructions


Advanced Options
Advanced Options for KIKSTART.EXE

Adding Your Own ICONS to KIKSTART.EXE

Using the KIKSTART.INI file for application configuration

Forcing your application to use KIKSTART.EXE

Back To:  Instructions


Adding Icons
Adding Icons to KIKSTART.EXE

MS Windows applications display icons in the Program Manager to indicate the program that executes when the user clicks on it. KIKSTART.EXE comes with several generic icons already embedded within the executable. You will probably want to add your own that will be visually associative with your application.

Selecting an ICON for Your Copy of KIKSTART.EXE

Make sure your copy of KIKSTART.EXE is installed in the MS Windows Program Manager.

See: Installing KIKSTART.EXE in the MS Windows Program Manager

1 	Single click on the KIKSTART.EXE icon.

2 	Open the 'Program Items Dialog' by pressing Alt+Enter or selecting File|Properties from the menu.

3 	Select the 'Change Icon' button. You will see all the currently installed icons.

4 	You may select one of the currently installed icons or select the 'Browse' button. With the Browser,  select a either stand alone *.ICO file or look for icons embedded in other EXE or DLL files.

Embedding an ICON Using a Resource Editing Tool

You can embed an icon directly into your copy of KIKSTART.EXE using a resource editing tool. Borland provides such a tool called the Resource Workshop that ships with the developer edition of Paradox and other Borland language products.

The Borland Resource Workshop includes an icon creation and editing utility. Once the icon has been created, it can be saved as an *.ICO format file and added as a resource (embedded) to your copy of KIKSTART.EXE.

Refer to the Resource Workshop documentation for additional information on this subject.

Back To: Advanced Options


Installing KIKSTART.EXE
Installing KIKSTART.EXE in the MS Windows Program Manager

•	Use the MS File Manager or DOS COPY.EXE in a DOS window to copy KIKSTART.EXE and KIKSTART.INI to the directory of your choice. Rename both files to the name of your choosing.

Example:

C:\>COPY KIKSTART.EXE C:\APPDIR\MYAPP.EXE
C:\>COPY KIKSTART.INI C:\APPDIR\MYAPP.INI

Remember: The EXE file requires an INI file of the same name.

•	In the MS Windows program Manager, either create a new one or use an existing program group. In the selected program group, create a new item.

File|New Group
File|New Item

•	Type in all the appropriate information in the New Item dialog box and press the OK button. Refer to Adding Icons for additional information.

•	Once KIKSTART.EXE and KIKSTART.INI are installed properly, you may use the Kickstart Configuration Utility or the MS Windows Notepad to edit the INI tags.

See Also:

Back To:  Instructions

Adding Icons

Kickstart Command Line Configuration Expert


KIKSTART.INI for Configuration
KIKSTART.INI for Application Configuration

The KIKSTART.INI file can serve a dual role and be used for general configuration for your application. The Paradox RTL methods ReadProfileString() and WriteProfileString() ( refer to the Paradox documentation for additional information on these methods) will read and write data to INI files.  By storing the INI file values as environment string variables, they can be accessed throughout the application.

INI Configuration Example:

;Sample INI file values

[System]

;System Defaults
DefaultAreaCode=609
DefaultZipCode=80222
DefaultReportCopies=1
DefaultFaxCopies=1
LastAccess=62904403390620.00
PrimaryPrinter=HP Laserjet 4/4M
PrimaryPort=LPT1
FaxName=WINFAX
FaxPort=COM1

{***************************************************
*        TITLE: cmGetIniSettings()
*
*  DESCRIPTION: Get INI settings and store in environment Variables
*
* RETURN VALUE: False if ini file was not found, otherwise true
****************************************************}
method cmGetIniSettings(stINIFile string) logical
var
  st    string      ;string var
  lg    logical    ;return variable
endvar

lg = true

while (true)

 if not isFile(stINIFile) then
   lg = false
   sound(75,100)
   msgStop("DIRECTORY ERROR",stINIFile + "File not found.")
   quitLoop
 endif

 ;set application INI file pointer
 writeEnvironmentString("APPINIFILE",stINIFile)

;[SYSTEM] tag

;dafault area code
  st = ""
  st = readProfileString(stINIFile,"SYSTEM","DefaultAreaCode")
  WriteEnvironmentString("DEFAULTAREACODE",st)

;dafault zip code
  st = ""
  st = readProfileString(stINIFile,"SYSTEM","DafaultZipCode")
  WriteEnvironmentString("DEFAULTZIPCODE",st.Upper())

  ;Default report copies
  st = ""
  st = readProfileString(stINIFile,"SYSTEM","DefaultReportCopies")
  WriteEnvironmentString("DEFAULTREPORTCOPIES",st.Upper())

  ;Default fax copies
  st = ""
  st = readProfileString(stINIFile,"SYSTEM","DefaultFaxCopies")
  WriteEnvironmentString("DEFAULTFAXCOPIES",st.Upper())

  ;last access date time
  st = ""
  st = readProfileString(stINIFile,"SYSTEM","LastAccess")
  WriteEnvironmentString("LASTACCESS",st.Upper())

  ;Primary printer
  st = ""
  st = readProfileString(stINIFile,"SYSTEM","PrimaryPrinter")
  WriteEnvironmentString("PRIMARYPRINTER",st.Upper())

  ;PrimaryPort
  st = ""
  st = readProfileString(stINIFile,"SYSTEM","PrimaryPort")
  WriteEnvironmentString("PRIMARYPORT",st.Upper())

  ;Fax name
  st = ""
  st = readProfileString(stINIFile,"SYSTEM","FaxName")
  WriteEnvironmentString("FAXNAME",st.Upper())

  ;FaxPort
  st = ""
  st = readProfileString(stINIFile,"SYSTEM","FaxPort")
  WriteEnvironmentString("FAXPORT",st.Upper())

  quitLoop

 endWhile

 return lg
endmethod

Back To:  Advanced Options


Forcing KIKSTART.EXE
Forcing Your Application to use KIKSTART.EXE

To maintain consistency and control over your applications you can require them to uses KIKSTART.EXE when starting.

After successfully passing all validations, KIKSTART.EXE writes to an INI file called KIKTRAIL.INI. The location defaults to the private directory but is placed in the working directory when no private directory is specified in the KIKSTART.INI file. If the file does not exist, it will be created.

Sample KIKTRAIL.INI File

;KIKTRAIL.INI

[KICKSTART]
KikTrail=true

Using objectPAL, from your start-up form or script, use the method ReadProfileString() to obtain the value of the KikTrail tag in KIKTRAIL.INI.

If the value is "true", then immediately set it to "false" using the method WriteProfileString() and allow the execution of the application to proceed.

If the value is "false",  display a warning message to the user that the application must be started using the file Kickstart executable, and exit Paradox.

For additional information on the methods ReadProfileString() and WriteProfileString() see your ObjectPAL run-time library reference.

ObjectPAL Code Sample:

;Sample ObjectPAL requiring your application to use
;the KickStart executable.

;Place method in startup script or library.
method cmForceKickstart() logical
var
  lg   logical
endvar
lg = true
view(privDir() + "\\KIKTRAIL.INI")
if isFile(privDir() + "KIKTRAIL.INI") then
  if Upper(readproFileString(privDir() + "KIKTRAIL.INI","Kickstart","Kicktrail")) = "TRUE" then
    WriteproFileString(privDir() + "KIKTRAIL.INI","Kickstart","Kicktrail","FALSE")
  else
   lg = false
  endif
else
  lg = false
endif
 return lg
endmethod

;Place this in your startup file
if not cmForceKickstart() then
  sound(75,100)
  msgStop("STARTUP ERROR", "This application must be started using MYAPP.EXE")
  ;Abort startup process here
endif

Back To:  Advanced Options


Peer to Peer Configuration

Peer to Peer networks (such as MS Windows for Workgroups) are like high-rise apartment buildings. One person's ceiling is another person's floor.

Likewise, the application and the data might reside on the C:\ drive for one workstation, to another workstation the same drive might be mapped as the E:\ drive.

To insure that all workstations are pointing to the correct data directory, copy the KIKSTART.INI file to the private directory and pass its name and location to KIKSTART.EXE using the [ -i ] command line override.

Example:

R:\APPS\MYAPP.EXE -iC:\PRIV\MYAPP.INI

It is also a good idea to create private IDAPI.CFG files to insure they are pointing to the correct network control file.

Back To:  Instructions


Kickstart Features

Starts Paradox applications with an executable file with the name of your choice.

Greatly simplifies the application distribution process.

Shields end users from Paradox's complex command line options.

Use command line options that exceed the Windows/DOS 128 character limit.

Verifies path and file name existence before calling Paradox.

Checks drive space on the working and private directory drives before calling Paradox.

Includes the Kickstart Command Line Configuration Expert to easily modify the parameters in KIKSTART.INI and create new instances of Kickstart.

Back to: Contents


Ordering Information
How to Order Kickstart

The complete working demo is available free of charge however, the demo notice displays each time the program is run. The commercial version has no such notice and its operation is invisible to the end user.

Ordering Options:

Royalty Free - Unlimited Runtime Only $49.95

Allows royalty-free distribution of KIKSTART.EXE with your Paradox applications.

Price includes Kickstart, the Kickstart Command Line Configuration Expert, Comprehensive On-line Help, and a Printed Manual.

With ObjectPAL Expert Source Code Only $99.95

As above but we include the objectPAL source code for the Kickstart Expert.

Credit Cards

We accept American Express, VISA and Master Card

Orders Only:  (800) 305-7830

Product Information and International Orders: (609) 227-0202

Order lines are open M-F  8am-6pm EST

Company Check

Mail Company Check to:

  Datacraft, Inc.
  P.O. Box 5645
  Deptford, NJ  08096

Please include full company address and phone number with order.

Include $5.00 for shipping and handling, $15.00 for orders outside the U.S.

New Jersey residents please add 6% sales tax.

Back to: Contents


Tech Support
Obtaining Technical Support

Compuserve

Direct messages to:

Kickstart Support
Compuserve ID: 76570,234

Internet

Direct messages to:

Kickstart Support
Address:  76570.234@compuserve.com

Telephone

Between 9:00 am  and  5:00 pm Eastern Standard Time

Voice:  (609) 227-0202

Fax:     (609) 374-1704

A technical support engineer will return your call as soon as possible.

Contents


About Datacraft
Database Solutions for Today's Business

Services:

We design and build custom database systems for businesses using Paradox for Windows and Paradox for DOS.

We develop customized corporate training, tailored to meet the needs of your developers.

We perform independent code review  with your staff and will advise you of potential problem areas and/or performance enhancements.

We design and create developer tools to enhance your team's efficiency and productivity.

Back to: Contents


Special Thanks To
A Special Thanks to the Following Individuals:

Bill Todd
Bob Clark
Bob Lenarcik
Brian Bushay
Dan Ehrmann
Diane Rogers
Don Schubert
Emery Galambos
James Kocis
Joe Fung
John B. Moore
Keith Bigelow
Lance Leonard
Luke Chung
Peter Brander
Robert Muir
Tarik Ghbeish
Vince Kellen
Steve Dickinson
Wolf Kadavanich

Back to: Contents